set -e

# for 1 gpu
# CUDA_VISIBLE_DEVICES=0
python -m torch.distributed.launch --nproc_per_node 4 \
    train_dist_mod.py --num_point 50000 --num_decoder_layers 6 \
    --num_encoder_layers 3 --deformable --deform --batch_size 3 \
    --size_delta 0.111111111111 --center_delta 0.04 --use_color \
    --learning_rate 0.006 --decoder_learning_rate 0.0006 --weight_decay 0.0005 \
    --dataset scannet --data_root ./dataset/language_grounding/scans/ \
    --log_dir ./logs/full_train_mod --val_freq 1 --save_freq 1


# for 4 gpus voltas
# python -m torch.distributed.launch --nproc_per_node 4 \
#     train_dist.py --batch_size 8 --num_point 50000 --width 2 --num_decoder_layers 12 --num_target 512 \
#     --size_delta 0.111111111111 --center_delta 0.04 --use_color \
#     --learning_rate 0.006 --decoder_learning_rate 0.0006 --weight_decay 0.0005 \
#     --dataset scannet --data_root ./dataset/language_grounding/scans/ --log_dir ./logs/full_train \
#     --checkpoint_path ./logs/full_train/group_free/scannet_1621627491/18032397/ckpt_epoch_400.pth
