set -e

# for 1 gpu
TORCH_DISTRIBUTED_DEBUG=INFO CUDA_VISIBLE_DEVICES=1,2,3 CUDA_BLOCKING_LAUNCH=1 python -m torch.distributed.launch --nproc_per_node 3 --master_port $RANDOM \
    train_dist_mod.py --num_point 50000 --num_decoder_layers 6 \
    --use_color \
    --weight_decay 0.0005 \
    --data_root ./dataset/language_grounding/scans/ \
    --val_freq 5 --batch_size 6 --save_freq 5 \
    --size_cls_agnostic --use_hungarian --print_freq 1000 \
    --lr_backbone=1e-4 --text_encoder_lr=1e-5 --lr=1e-4 \
    --no_sa_vis --no_sa_lang \
    --dataset scanrefer --test_dataset scanrefer \
    --detect_intermediate --joint_det \
    --butd \
    --use_soft_token_loss --use_contrastive_align \
    --log_dir ./logs/scanrefer_correct \